local L = LibStub("AceLocale-3.0"):NewLocale("MorgDKP2_Options", "enUS", true)

if L then	
	--main
	L["Allow the OFFSPEC button to be used in MorgBid2."] = true
	L["Allow updating bid results in MorgBid2."] = true
	L["Automatically enable MorgDKP2 and start a raid when entering a trackable zone."] = true
	L["Autozone"] = true
	L["Background color"] = true
	L["Background texture of frames/tooltips."] = true
	L["Background texture"] = true
	L["Border color"] = true
	L["Border texture of frames/tooltips."] = true
	L["Border texture"] = true
	L["Clear currently tracked raids."] = true
	L["Clear the raid database?"] = true
	L["Core Modules"] = true
	L["Core of all MorgDKP2 features."] = true
	L["Core Options"] = true
	L["Custom MorgBid2"] = true
	L["Determine MorgBid user base. \nAlso useful to check DKP for alts."] = true
	L["Developer mode"] = true
	L["Display Options"] = true
	L["DKP Modules"] = true
	L["Enable ML/DE mode"] = true
	L["Enable tooltip hints"] = true
	L["Enable"] = true
	L["Enables changing the text of button hints in MorgBid2."] = true
	L["Enables nagging outdated MorgBid2 users."] = true
	L["Font color"] = true
	L["Font size"] = true
	L["Font used in tooltips and frames."] = true
	L["Font"] = true
	L["Frame scale"] = true
	L["General display options for main modules."] = true
	L["If ML/DE Mode is on then no items will be recorded for the master looter or disenchanter defined by MorgDKP2."] = true
	L["Ignore 6-8"] = true
	L["Ignore items worn by members.  This means queries will always be sent even if they have the item."] = true
	L["Ignore members in groups 6-8 when querying for items."] = true														
	L["Ignore worn"] = true
	L["ILvl"] = true
	L["Invite DKP format"] = true
	L["Link items on the boss/mob that are above the loot threshold to guild chat."] = true
	L["Link items on the boss/mob that are above the loot threshold to raid chat."] = true
	L["Link to Guild"] = true
	L["Link to Raid"] = true
	L["Morgbid check"] = true
	L["MorgBid2 Nag"] = true
	L["MorgBid2 Options"] = true
	L["MorgBid2 updating"] = true
	L["NEED text"] = true
	L["OFFSPEC text"] = true
	L["Only items above this iLvl will be saved in the players equipment DB."] = true
	L["PASS text"] = true
	L["Show minimap icon"] = true
	L["TAKE text"] = true
	L["Text of MorgBid2 NEED button"] = true
	L["Text of MorgBid2 OFFSPEC button"] = true
	L["Text of MorgBid2 PASS button"] = true
	L["Text of MorgBid2 TAKE button"] = true
	L["Toggle MorgDKP2"] = true
	L["Use DKP balance/earned DKP/attendance in the invite tablet (shift-click)."] = true
	L["Use OFFSPEC"] = true
	L["Whisper system"] = true
	L["Whispers all members (even if they have MorgBid2) so they can reply and bid using whispers."] = true
	
	--dkptypes
	L["BidWar"] = true
	L["Boss Attempt Mode"] = true
	L["Fixed DKP"] = true
	L["Percent DKP"] = true
	L["Random rolls"] = true
	L["Relational DKP"] = true
	L["SKall DKP"] = true
	L["SKSotC DKP"] = true
	L["TakeBid DKP"] = true
	L["Zerosum DKP"] = true
	
	--tracker
	L["Attendance based NEED"] = true
	L["Attendance reward"] = true
	L["Attendance value(%) for new members to the database."] = true
	L["Bank character"] = true
	L["Core of all MorgDKP2 raid tracking features. \nCan not be disabled."] = true
	L["DKP listener"] = true
	L["DKP Tracking"] = true
	L["DKP which new members to the database receive."] = true
	L["End Raid"] = true
	L["Eqdkp+ event format"] = true
	L["Events for DKP changes"] = true
	L["Export format"] = true
	L["Export Raids"] = true
	L["Exports current raid(s) data for import into website."] = true
	L["Finalizes the current raid."] = true
	L["Format of new member DKP event name."] = true
	L["Format to use for raid exports."] = true
	L["General options"] = true
	L["Minimum attendance percentage to allow MorgBid2 clients to roll NEED. 0 is disabled."] = true
	L["Minimum time to add member to raid and award run DKP."] = true
	L["New member DKP event"] = true
	L["New member initial attendance"] = true
	L["New member start DKP"] = true
	L["Opens the raidtracker interface."] = true
	L["Raid Tracker"] = true
	L["Remember kill times"] = true
	L["Remove the ' character from any event names because eqdkp+ is dumb."] = true
	L["Shortcuts"] = true
	L["Single run event"] = true
	L["Start Event"] = true
	L["Start Raid"] = true
	L["Starts a new raid."] = true
	L["Store your best kill times for bosses."] = true
	L["Use a bank character in raids."] = true
	L["Use events for DKP changes instead of database adjustments."] = true
	L["Use one event for entire raid.  Boss kills will not be tracked separately."] = true
	L["Use start event when raid begins."] = true
	L["When you are in a tracked zone you will track DKP but you will not get the loot popup window or link to the raid.  You will act like a backup raidlog."] = true
	
	--lootframe
	L["Always use the MorgDKP2 loot window even when the mod is in standby mode."] = true
	L["Always use"] = true
	L["Lootframe"] = true
	L["Lootframe scale"] = true
	L["Open lootframe at cursor postition"] = true
	L["Replace Blizzard"] = true
	L["Snap to cursor"] = true
	L["When MorgDKP2 is active it's loot frame will replace default."] = true
	
	--pointsDB
	L["Add ignored item"] = true
	L["Add item"] = true
	L["Add new item to ignore.  Drag the item to this input box."] = true
	L["Add new item to track.  Drag the item to this input box."] = true
	L["Added %s to item database."] = true
	L["Clear player DB"] = true
	L["Clear raid DB"] = true
	L["Clears all items in the database below the selected item level."] = true
	L["Clears all members in the database inactive longer than the selected number of weeks."] = true
	L["Clears all players currently in the database. Does not affect items."] = true
	L["Clears the current tracked raids."] = true
	L["Cull item DB"] = true
	L["Cull item level"] = true
	L["Cull member DB"] = true
	L["Cull member level (weeks)"] = true
	L["Current rank weight"] = true
	L["Database Functions"] = true
	L["Higher number for higher display priority. (7 will appear above 3 on the tooltip)"] = true
	L["Ignored items"] = true
	L["List of currently ignored items.  Click to remove item from ignore list."] = true
	L["List of member ranks in the current pool."] = true
	L["Player database cleared!"] = true
	L["Player DKP reset to zero!"] = true
	L["Rank weights"] = true
	L["Removed %s items from the database."] = true
	L["Removed %s members from the database."] = true
	L["Resets all members DKP to zero."] = true
	L["Zero player DB"] = true
	
	--syncing
	L["Accept DKP changes from other raid leaders."] = true
	L["Automatic"] = true
	L["Automatically set broadcast/receive depending if you are the master looter."] = true
	L["Broadcast DKP changes to other raid leaders."] = true
	L["Broadcast"] = true
	L["Enable"] = true
	L["Immediate Sync Options"] = true
	L["Initial Sync"] = true
	L["Items Sync"] = true
	L["Members Sync"] = true
	L["Options Sync"] = true
	L["Overwrite raid"] = true
	L["Overwrite the current raid if you receive an initial sync and are currently in a raid."] = true
	L["Password"] = true
	L["Receive"] = true
	L["Resends initial sync.  Only needed in cases where you have problems as this is done automatically."] = true
	L["Send DB Sync"] = true
	L["Sends your current database of item DKP values."] = true
	L["Sends your current database of member DKP values, item values, and MorgDKP2 options to the current raid."] = true
	L["Sends your current database of member DKP values."] = true
	L["Sends your current MorgDKP2 options.  Note will restart MorgDKP2 so do not send another sync until it restarts or use full sync and it will be handled properly."] = true
	L["Syncing password"] = true
	L["Syncing system for communicating DKP between raid leaders."] = true
	L["Syncing"] = true
	
	--bidwar
	L["Bidstep"] = true
	L["BidWar mode changes the MorgBid query to allow players to bid on items.  Also the MorgDKP tablet uses bids after this NOT member DKP."] = true
	L["BidWar Options"] = true
	L["BidWar"] = true
	L["Changes the DKP step for BidWar mode.  Passes this value to MorgBid2 clients."] = true
	L["Enable BidWar mode where the winner is charged the 2nd highest bid value for the item."] = true
	L["Enable BidWar mode with only one round of bidding and no reporting to raid chat."] = true
	L["Just enough"] = true
	L["Maximum amount of DKP that members can exceed their current DKP."] = true
	L["Overbid"] = true
	L["Silent auction"] = true
	
	--waitlist
	L["Amount of DKP to reward after members have been on the waitlist for the current reward time."] = true
	L["Amount of DKP to reward at raidstart."] = true
	L["Amount of DKP to reward to waitlist members per bosskill."] = true
	L["Amount of DKP to reward to waitlist members when awarding regular members DKP/time. Note: only works if you are awarding DKP/time."] = true
	L["Autochannel Spam"] = true
	L["Award DKP to current waitlist members"] = true
	L["Award DKP"] = true
	L["Channels to spam when starting invites."] = true
	L["Channels"] = true
	L["Clear Waitlist"] = true
	L["Clears the current wailist."] = true
	L["Event Names"] = true
	L["Format of waitlist boss events:  \n<boss> text  \nExample:  <boss> Waitlist DKP"] = true
	L["Format of waitlist event names:  \n<zone> text  \nExample:  <zone> Waitlist DKP"] = true
	L["Grace Period"] = true
	L["Minimum time before offline waitlist members will be removed."] = true
	L["Minimum time to award run DKP to a waitlist member."] = true
	L["Spam channels automatically when opening the invite tablet."] = true
	L["Spam channels with current waitlist."] = true
	L["Spam channels with waitinfo now."] = true
	L["Spam Current"] = true
	L["Spam Waitinfo"] = true
	L["Waitlist allows members to whisper you for invites and to receive DKP even if not in the actual raid."] = true
	L["Waitlist boss DKP"] = true
	L["Waitlist boss event name"] = true
	L["Waitlist DKP/time"] = true
	L["Waitlist event name"] = true
	L["Waitlist reward"] = true
	L["Waitlist run DKP"] = true
	L["Waitlist spamming"] = true
	L["Waitlist start DKP"] = true
	L["Waitlist"] = true
	
	L["Waitlist add time"] = true
	L["Maximum time to allow new members to join the waitlist after raidstart. (0 to disable)"] = true
	
	--dkp/time
	L["Award amount"] = true
	L["Award immediately"] = true
	L["Award time"] = true
	L["DKP awards will ignore required minimum time in raid."] = true
	L["DKP/time event name"] = true
	L["DKP/time Options"] = true
	L["DKP/time system which allows you to award DKP at custom intervals."] = true
	L["DKP/time"] = true
	L["Format of event name:  \n<zone> text  \nExample:  <zone> DKP"] = true
	L["Time in minutes between DKP awards."] = true
	
	--eventnaming
	L["Allows you to change the default format for event names."] = true
	L["Boss format"] = true
	L["Default"] = true
	L["Event naming"] = true
	L["Format of boss event names:  \n<zone> - <boss>\nExample:  <boss> <diff>"] = true
	L["Format of run event name:  \n<zone> text  \nExample:  <zone> <diff> Run"] = true
	L["Format of start event name:  \n<zone> text  \nExample:  <zone> <diff> Start"] = true
	L["Reset default values."] = true
	L["Run format"] = true
	L["Start format"] = true
	L["Toggle event naming"] = true
	
	--fixed dkp
	L["DKP TAKE/OFFSPEC settings"] = true
	L["Enable OFFSPEC"] = true
	L["Enable TAKE"] = true
	L["Enables mode where members are charged a standard price for OFFSPEC items."] = true
	L["Enables mode where members are charged a standard price for TAKE items."] = true
	L["Enables mode where the winner is charged a set price if only the winner rolled NEED."] = true	
	L["OFFSPEC Percent"] = true
	L["OFFSPEC value"] = true
	L["Single NEED value"] = true
	L["Single NEED"] = true
	L["Standard DKP system."] = true
	L["TAKE Percent"] = true
	L["TAKE value"] = true
	L["Use percent of item value for OFFSPEC mode."] = true
	L["Use percent of item value for TAKE mode."] = true
	
	--percent dkp
	L["Items will cost a percentage of the members total DKP."] = true
	L["Percent cost"] = true
	L["Percent DKP Options"] = true
	L["Percent take"] = true
	L["When using the percent DKP system this option enables TAKE looting.  This means if the winning member rolled TAKE he will not be charged x% DKP he will instead be charged the base price of the item (Set using original itempoints."] = true
	
	--random
	L["Enable random rolling for items."] = true
	L["Random Options"] = true
	L["Weighted Random"] = true
	L["Use attendance percent as a multiplier for random rolls. (roll * att/100)"] = true
			
	--relational
	L["BaseGP"] = true
	L["Enable Relational DKP for calculating the earned/spent dkp ratio."] = true
	L["GP all members have, added to what they've actually spent on gear. I.e.  EP/(GP + BaseGP)"] = true
	L["Minimum amount of GP a member can have for calculating the DKP ratio to avoid a new member having a high ratio. ie  200 earned DKP/ (this value)"] = true
	L["Minimum GP"] = true
	L["Relational DKP Options"] = true
	
	--skall
	L["Enable raid award"] = true
	L["Enables DKP removed from item winner to be awarded to raid members.  You must check use zerosum on the import webscript for website DKP to be correct."] = true
	L["Enable Suicide Kings spend all DKP."] = true
	L["% Member DKP"] = true
	L["Percent of member DKP to remove."] = true
	L["SKall Options"] = true
	
	--sksotc
	L["Amount of DKP to remove from members who miss a raid."] = true
	L["Demotion event"] = true
	L["Enable Suicide Kings SotC variant DKP."] = true
	L["Format of event name:  \n<zone> text  \nExample:  <zone> DKP"] = true
	L["Missed raid DKP"] = true
	L["SKSotC Options"] = true
	
	--takebid
	L["Changes the DKP step for TakeBid mode.  Passes this value to MorgBid2 clients."] = true
	L["Maximum amount of DKP that members can exceed their current DKP."] = true
	L["TakeBid Options"] = true
	L["Minimum bid"] = true
	L["Minimum amount of DKP that members can bid for an item."] = true
	L["Variation of Fixed DKP where when you bid take you also enter what you are willing to pay."] = true
	L["Bidstep"] = true
	L["Overbid"] = true
	
	--zerosum
	L["Added %s DKP to %s attendees."] = true
	L["DKP award event name"] = true
	L["Format of event name:  \n<zone> text  \nExample:  <zone> DKP"] = true
	L["Include waitlist"] = true
	L["Include waitlist members in DKP calculations.  Note they will still get whatever DKP award is set in the waitlist module."] = true
	L["Standard zero sum system where member is charged for the item and the charged points are divided between all raid members.  You must check use zerosum on the import webscript for website DKP to be correct."] = true
	L["Zerosum Options"] = true
end

local L = LibStub("AceLocale-3.0"):NewLocale("MorgDKP2_Options", "deDE")
	
if L then
	L["Accept DKP changes from other raid leaders."] = "Aktzeptiere DKP-Veränderungen anderen Raidleiter."
L["Added %s DKP to %s attendees."] = "%s DKP zu %s Teilnehmern hinzugefügt."
L["Add ignored item"] = [=[Ignorierten Gegenstand zufügen

PunkteDB]=]
L["Add item"] = "Gegenstand zufügen"
L["Add new item to ignore.  Drag the item to this input box."] = [=[Neuen Gegenstand zur Ignoreliste hinzufügen. Den Gegenstand in die Box ziehen.

PunkteDB]=]
L["Add new item to track.  Drag the item to this input box."] = "Neuen Gegenstand hinzufügen.  Den Gegenstand einfach in die Box ziehen."
L["Allows you to change the default format for event names."] = "Erlaubt es, eigene Namen für die Events zu erstellen."
L["Allow the OFFSPEC button to be used in MorgBid2."] = "Erlaubt es, den OFFSPEC Knopf in MorgBid2 zu verwenden."
L["Allow updating bid results in MorgBid2."] = "Erlaubt es, Bietergebnisse in MorgBid2 nachträglich zu verändern."
L["Always use"] = "Immer nutzen"
L["Always use the MorgDKP2 loot window even when the mod is in standby mode."] = "Das MorgDKP2 Lootfenster auch dann benutzen, wenn MorgDKP2 im Standby Modus ist."
L["Amount of DKP to reward after members have been on the waitlist for the current reward time."] = "Anzahl der DKP, die Leute in der Warteliste nach der vorgegebenen Wartezeit erhalten."
L["Amount of DKP to reward at raidstart."] = "Anzahl der DKP, die Leute in der Warteliste beim Raidbeginn erhalten."
L["Amount of DKP to reward to waitlist members per bosskill."] = "Anzahl der DKP, die Leute in der Warteliste pro Bosskill bekommen."
L["Amount of DKP to reward to waitlist members when awarding regular members DKP/time. Note: only works if you are awarding DKP/time."] = "Anzahl an DKP über Zeit, die Leuten in der Warteliste zugeteilt wird. Funktioniert nur, wenn man DKP über Zeit vergibt."
L["Attendance based NEED"] = "Anwesenheits-basierter BEDARF"
L["Attendance reward"] = "Zeit für Teilnahmebonus"
L["Autochannel Spam"] = "Automatisch posten"
L["Automatic"] = "Automatisch"
L["Automatically enable MorgDKP2 and start a raid when entering a trackable zone."] = "Schaltet MorgDKP2 automatisch ein, wenn eine Raidzone betreten wird."
L["Automatically set broadcast/receive depending if you are the master looter."] = "Wenn du Plündermeister bist automatisch Beute verkünden."
L["Autozone"] = "Autozone"
L["Award amount"] = "DKP Menge"
L["Award DKP"] = "DKP zuweisen"
L["Award DKP to current waitlist members"] = "DKP an Leute zuweisen, die sich im Moment in der Warteliste befinden."
L["Award time"] = "Zeitraum"
L["Background color"] = "Hintergrundfarbe"
L["Background texture"] = "Hintergrundmuster"
L["Background texture of frames/tooltips."] = [=[Muster, das für den Hintergrund von 
Fentern und Tooltips verwendet wird.]=]
L["Bank character"] = "Bank Charakter"
L["Bidstep"] = "Bietschritt"
L["BidWar"] = "Biet-DKP"
L["BidWar mode changes the MorgBid query to allow players to bid on items.  Also the MorgDKP tablet uses bids after this NOT member DKP."] = "Biet-DKP ändert MorgBid2 so ab, dass Mitspieler auf Gegenstände bieten können.  MorgDKP zeigt bei Biet-DKP die Gebote an, nicht die DKP der Mitspieler."
L["BidWar Options"] = "Gebotsschlacht Optionen"
L["Border color"] = "Rahmenfarbe"
L["Border texture"] = "Rahmenmuster"
L["Border texture of frames/tooltips."] = [=[Muster, das für Rahmen von 
Fenstern und Tooltips verwendet wird.]=]
L["Boss Attempt Mode"] = "Bossversuchsmodus"
L["Boss format"] = "Boss Format"
L["Broadcast"] = "Nachricht an alle Benutzer"
L["Broadcast DKP changes to other raid leaders."] = "Teile DKP-Änderung mit den anderen Schlachtzugsleitern."
L["Changes the DKP step for BidWar mode.  Passes this value to MorgBid2 clients."] = "Die DKP Schritte ändern, in denen geboten werden kann.  Dieser Wert wird an MorgBid2 übergeben."
L["Changes the DKP step for TakeBid mode.  Passes this value to MorgBid2 clients."] = "Ändert die Schrittweite für Gebote beim Biet-DKP System. Dieser Wert wird an MorgBid2 übergeben."
L["Channels"] = "Kanäle"
L["Channels to spam when starting invites."] = "Kanäle, in die die Nachricht zum Laden gepostet wird."
L["Clear currently tracked raids."] = "Aufgezeichnete Raids löschen."
L["Clear player DB"] = "Spieler DB löschen"
L["Clear raid DB"] = "Raid DB löschen"
L["Clears all items in the database below the selected item level."] = "Alle Gegenstände aus der Datenbank löschen, die unter der ausgewählten Gegenstandsstufe liegen."
L["Clears all members in the database inactive longer than the selected number of weeks."] = "Löscht alle Mitglieder in der Datenbank, welche länger als die eingestellte Anzahl an Wochen inaktiv sind."
L["Clears all players currently in the database. Does not affect items."] = "Alle Spieler löschen, die Momentan in der Datenbank sind. Wirkt sich nicht auf Gegenstände aus."
L["Clears the current tracked raids."] = "Alle aufgezeichneten Raids löschen."
L["Clears the current wailist."] = "Die momentane Warteliste löschen."
L["Clear the raid database?"] = "Raid Datenbank löschen?"
L["Clear Waitlist"] = "Warteliste löschen"
L["Core Modules"] = "Zentrale Module"
L["Core of all MorgDKP2 features."] = "Standard MorgDKP2 Features."
L[ [=[Core of all MorgDKP2 raid tracking features. 
Can not be disabled.]=] ] = [=[Kern der MorgDKP2 Aufzeichnung. 
Kann nicht abgeschaltet werden.]=]
L["Core Options"] = "Allgemeine Einstellungen"
L["Cull item DB"] = "Gegenstandsliste säubern"
L["Cull item level"] = "Gegenstandsstufe"
L["Cull member DB"] = [=[Mitglieder DB kürzen

PunkteDB]=]
L["Cull member level (weeks)"] = [=[Mitglieder DB kürzen (Wochen)

PunkteDB]=]
L["Current rank weight"] = [=[Aktuelles Gewicht des Ranges

PunkteDB]=]
L["Custom MorgBid2"] = "MorgBid2 anpassen"
L["Database Functions"] = "Datenbank Funktionen"
L["Default"] = "Zurücksetzen"
L[ [=[Determine MorgBid user base. 
Also useful to check DKP for alts.]=] ] = [=[MorgBid Nutzerbasis wählen. 
Ebenfalls nützlich zur DKP Überprüfung von Alts.]=]
L["Developer mode"] = "Entwicklermodus"
L["Display Options"] = "Anzeigeoptionen"
L["DKP award event name"] = "Eventname der DKP Zuweisung"
L["DKP listener"] = "DKP Backup"
L["DKP Modules"] = "DKP Module"
L["DKP TAKE/OFFSPEC settings"] = "DKP Erst-/Zweitbedarf Einstellungen"
L["DKP/time"] = "DKP/Zeit"
L["DKP/time event name"] = "Eventname für DKP über Zeit"
L["DKP/time Options"] = "DKP/Zeit Optionen"
L["DKP/time system which allows you to award DKP at custom intervals."] = "DKP über Zeit System, dass den Teilnehmern feste DKP pro Zeitintervall gutschreibt."
L["DKP Tracking"] = "DKP Aufzeichnung"
L["DKP which new members to the database receive."] = "Anzahl der DKP, die neue Raidteilnehmer automatisch erhalten."
L["Earned DKP for Invites"] = "Erhaltene DKP für Invite"
L["Enable"] = "Aktiv"
L["Enable BidWar mode where the winner is charged the 2nd highest bid value for the item."] = "Biet-DKP, bei der der Gewinner das zweithöchste Gebot zahlt."
L["Enable BidWar mode with only one round of bidding and no reporting to raid chat."] = "Biet-DKP, in der nur eine einzige Bietrunde stattfindet und keine Punkte an den Raid gesendet werden."
L["Enable ML/DE mode"] = "ML/DE Modus aktiv"
L["Enable OFFSPEC"] = "Aktiviere Zweitbedarf"
L["Enable raid award"] = "Aktiviere Raidbelohnung"
L["Enable random rolling for items."] = "Zufälliges Würfeln für Gegenstände einschalten."
L["Enable Relational DKP for calculating the earned/spent dkp ratio."] = "Verhältnis DKP System aktivieren, um einen Faktor Erhalten/Ausgegeben zu errechnen."
L["Enables changing the text of button hints in MorgBid2."] = "Den Tooltip der MorgBid2 Knöpfe anpassen."
L["Enables DKP removed from item winner to be awarded to raid members.  You must check use zerosum on the import webscript for website DKP to be correct."] = "Aktiviert das dem Gegenstandsgewinner die DKP abgezogen und den Raidteilnehmern gutschrieben werden. Es muss ZeroSum im Import-Webskript aktiviert sein, damit das auf den Webseiten DKP richtig funktioniert."
L["Enables mode where members are charged a standard price for OFFSPEC items."] = "Aktiviert den Modus, das Teilnehmern ein Standardpreis auch für Zweitausrüstung abgezogen wird."
L["Enables mode where members are charged a standard price for TAKE items."] = "Aktiviert den Modus, das Teilnehmern ein Standardpreis für Erstausrüstung abgezogen wird."
L["Enable Suicide Kings spend all DKP."] = "Aktiviert 'Nur Selbstmörder geben alle DKP'."
L["Enable TAKE"] = "Aktiviere Erstbedarf"
L["Enable tooltip hints"] = "Tooltips einschalten"
L["End Raid"] = "Raid beenden"
L["Eqdkp+ event format"] = "EqDKP+ Format"
L["Event Names"] = "Namen der Events"
L["Event naming"] = "Ereignisnamen"
L["Events for DKP changes"] = "DKP Änderung als Ereignis"
L["Export Raids"] = "Raid exportieren"
L["Exports current raid(s) data for import into website."] = "Die Daten aller Raids für einen Import in die Webseite exportieren."
L["Finalizes the current raid."] = "Eine Raidaufzeichnung abschliessen."
L["Fixed DKP"] = "Feste DKP"
L["Font"] = "Schriftart"
L["Font color"] = "Zeichenfarbe"
L["Font size"] = "Schriftgröße"
L["Font used in tooltips and frames."] = "Schriftart, der in Tooltips und Fenstern benutzt wird."
L[ [=[Format of event name:  
<zone> text  
Example:  <zone> DKP]=] ] = [=[Format des Eventnamens:  
<zone> test  
Beispiel:  <zone> DKP]=]
L[ [=[Format of run event name:  
<zone> text  
Example:  <zone> <diff> Run]=] ] = [=[Format des Raidevents:  
<zone> text  
Beispiel:  <zone> <diff> Run]=]
L[ [=[Format of start event name:  
<zone> text  
Example:  <zone> <diff> Start]=] ] = [=[Format des Startevents:  
<zone> text  
Beispiel:  <zone> <diff> Start]=]
L[ [=[Format of waitlist boss events:  
<boss> text  
Example:  <boss> Waitlist DKP]=] ] = [=[Format des Eventnamens: <boss> text  
Beispiel: <boss> Warteliste DKP]=]
L[ [=[Format of waitlist event names:  
<zone> text  
Example:  <zone> Waitlist DKP]=] ] = [=[Format des Eventnamens: <zone> text  
Beispiel: <zone> Warteliste DKP]=]
L["Frame scale"] = "Fensterskalierung"
L["General display options for main modules."] = "Allgemeine Anzeigeoptionen für die Hauptmodule."
L["General options"] = "Grundlagen"
L["Grace Period"] = "Gnadenfrist"
L["Higher number for higher display priority. (7 will appear above 3 on the tooltip)"] = [=[Größere Zahl für höhere Priorität bei der Anzeige (7 erscheint oberhalb von 3 im Tooltip)

PunkteDB]=]
L["If ML/DE Mode is on then no items will be recorded for the master looter or disenchanter defined by MorgDKP2."] = "Wenn der ML/DE Modus aktiv ist, werden keine Gegenstände aufgezeichnet, die an den in MorgDKP2 eingestellten Lootmeister oder Entzauberer gehen."
L["Ignore 6-8"] = "Keine Gruppe 6-8"
L["Ignored items"] = "Ignorierte Gegenstände"
L["Ignore members in groups 6-8 when querying for items."] = "Leute der Gruppen 6-8 ignorieren, wenn Gegenstände vergeben werden."
L["Immediate Sync Options"] = "Sofortige Sync.-Optionen"
L["Include waitlist"] = "Mit Warteliste"
L["Include waitlist members in DKP calculations.  Note they will still get whatever DKP award is set in the waitlist module."] = "Leute in der Warteliste in die Berechnung einschlissen.  Bitte beachten: Die Leute in der Warteliste bekommen trotzdem die DKP Boni, die im Modul 'Warteliste' eingestellt wurden."
L["Initial Sync"] = "Erst Sync."
L["Invite DKP format"] = "DKP Format für Einladungen"
L["Items Sync"] = "Gegenstands Sync."
L["Items will cost a percentage of the members total DKP."] = "Gegenstände kosten einen bestimmten Prozentsatz der gesamten DKP des Spielers."
L["Just enough"] = "Genug ist Genug"
L["Link items on the boss/mob that are above the loot threshold to guild chat."] = "Schreibt die Gegenstände, die oberhalb der Lootschwelle sind, in den Gildenchat."
L["Link items on the boss/mob that are above the loot threshold to raid chat."] = "Schreibt die Gegenstände, die oberhalb der Lootschwelle sind, in den Raidchat."
L["Link to Guild"] = "Gildenchat Posts"
L["Link to Raid"] = "Raidchat Posts"
L["List of currently ignored items.  Click to remove item from ignore list."] = "Liste der Gegenstände, die im Moment ignoriert werden.  Klicken, um einen Gegenstand aus der Liste zu entfernen."
L["List of member ranks in the current pool."] = [=[Liste der Mitgliedsränge im momentanen Pool

PunkteDB]=]
L["Lootframe"] = "Lootfenster"
L["Lootframe scale"] = "Skalierung Lootfenster"
L["Maximum amount of DKP that members can exceed their current DKP."] = "Maximalwert an DKP, die über die momentanen DKP geboten werden darf."
L["Maximum time to allow new members to join the waitlist after raidstart. (0 to disable)"] = "Maximaler Zeitraum der neuen Mitgliedern nach Raidstart erlaubt der Warteliste beizutreten. (0 deaktiviert dieses Feature)"
L["% Member DKP"] = "% Mitglieder DKP"
L["Members Sync"] = "Mitglieder synchronisieren"
L["Minimum amount of DKP that members can bid for an item."] = [=[Mindestzahl an DKP, die Mitglieder auf einen Gegenstand bieten können.

NimmGebot]=]
L["Minimum attendance percentage to allow MorgBid2 clients to roll NEED. 0 is disabled."] = "Minimaler Anwesenheits-Prozentsatz der MorgBid2 Clients erlaubt BEDARF zu würfeln. 0 deaktiviert dieses Feature."
L["Minimum bid"] = [=[Minimales Gebot.

NimmGebot]=]
L["Minimum time before offline waitlist members will be removed."] = "Zeit in Minuten, bevor Leute aus der Warteliste geworfen werden, die Offline sind."
L["Minimum time to add member to raid and award run DKP."] = "Zeit in Minuten, die eine Person am Raid teilgenommen haben muss, um am dort gelistet zu werden und DKP für die Teilnahme zu erhalten."
L["Minimum time to award run DKP to a waitlist member."] = "Zeit, die man in der Warteliste verbracht haben muss, um DKP zu erhalten."
L["MorgBid2 Options"] = "MorgBid2 Optionen"
L["MorgBid2 updating"] = "MorgBid2 Update"
L["Morgbid check"] = "Morgbid Check"
L["NEED text"] = "Text für BEDARF"
L["New member start DKP"] = "Start DKP für neue Teilnehmer"
L["OFFSPEC Percent"] = [=[OFFSPEC Prozent

Feste DKP]=]
L["OFFSPEC text"] = "Text für OFFSPEC"
L["OFFSPEC value"] = "Zweitausrüstungskosten"
L["Open lootframe at cursor postition"] = "Das Lootfenster an der aktuellen Mausposition einblenden"
L["Opens the raidtracker interface."] = "Öffnet das Fenster des Raidtrackers."
L["Options Sync"] = "Optionen synchronisieren"
L["Overbid"] = "Überbieten"
L["Overwrite raid"] = "Überschreibe Raid"
L["Overwrite the current raid if you receive an initial sync and are currently in a raid."] = [=[Überschreibe den aktuellen Raid wenn du einen initialen Sync bekommst und in einem Raid bist.

Synchronisiere]=]
L["PASS text"] = "Text für PASSE"
L["Password"] = "Passwort"
L["Percent cost"] = "Kosten (Prozent)"
L["Percent DKP"] = "Prozent DKP"
L["Percent DKP Options"] = "Prozent DKP Optionen"
L["Percent of member DKP to remove."] = "Prozent des Mitglieder-DKP werden abgezogen."
L["Percent take"] = "GIER aktivieren"
L["Player database cleared!"] = "Spielerdatenbank gelöscht!"
L["Player DKP reset to zero!"] = "DKP aller Spieler zurückgesetzt!"
L["Raid Tracker"] = "Raid Tracker"
L["Random rolls"] = "Zufallswurf"
L["Rank weights"] = [=[Gewichtung der Ränge

PunkteDB]=]
L["Receive"] = [=[erhalten
]=]
L["Relational DKP"] = "Verhältnis DKP"
L["Relational DKP Options"] = [=[Relationale DKP Optionen

Relational]=]
L["Removed %s items from the database."] = [=[%s Teile aus der Datenbank entfernt.

PunkteDB]=]
L["Removed %s members from the database."] = [=[%s Mitglieder aus der Datenbank entfernt.

PunkteDB]=]
L["Remove the ' character from any event names because eqdkp+ is dumb."] = "Das ' Zeichen aus Eventnamen entfernrn - EqDKP+ kommt damit nicht klar."
L["Replace Blizzard"] = "Blizzards ersetzen"
L["Resends initial sync.  Only needed in cases where you have problems as this is done automatically."] = [=[Initialen Sync neu senden. Wird nur bei Probleme verwendet, weil dies normalerweise automatisch geschieht.

Synchronisiere]=]
L["Reset default values."] = "Auf Standardwerte zurücksetzen."
L["Resets all members DKP to zero."] = "Die DKP aller Teilnehmer löschen."
L["Run format"] = "Raid Format"
L["Send DB Sync"] = "Sende Data Base Sync."
L["Sends your current database of item DKP values."] = "Sendet die aktuelle Datenbank mit den Gegenstands-DKP-Preisen."
L["Sends your current database of member DKP values."] = "Sendet die aktuelle Datenbank mit den Mitglieder-DKP-Werten."
L["Sends your current database of member DKP values, item values, and MorgDKP2 options to the current raid."] = "Sendet die aktuelle Datenbank mit den Mitglieder-DKP-Werten,Item-Preisen und MorgDKP2-Optionen an den Schlachtzug."
L["Sends your current MorgDKP2 options.  Note will restart MorgDKP2 so do not send another sync until it restarts or use full sync and it will be handled properly."] = [=[Übermittelt deine momentanen MorgDKP2 Einstellungen. Bemerkung: MorgDKP2 wird danach neu gestartet, also vor dem Neustart keinen weiteren Sync schicken. Alternativ: Einen Vollsync machen, dann wird auch alles richtig verarbeitet.

Synchronisiere]=]
L["Shortcuts"] = "Kürzel"
L["Show minimap icon"] = "Minimap Icon anzeigen"
L["Silent auction"] = "Geheime Auktion"
L["Single run event"] = "Nur ein Eintrag"
L["SKall DKP"] = "SKall DKP"
L["SKall Options"] = "SKall Optionen"
L["Snap to cursor"] = "Einblenden bei Maus"
L["Spam channels automatically when opening the invite tablet."] = "Automatisch in Kanäle posten, wenn das Ladefenster geöffnet wird."
L["Spam channels with current waitlist."] = "Spamme Channels mit aktueller Warteliste."
L["Spam channels with waitinfo now."] = "Jetzt die Info zur Warteliste posten."
L["Spam Current"] = "Spamme Aktuelle"
L["Spam Waitinfo"] = "Jetzt posten"
L["Standard DKP system."] = "Standard DKP System."
L["Standard zero sum system where member is charged for the item and the charged points are divided between all raid members.  You must check use zerosum on the import webscript for website DKP to be correct."] = "Standard Nullsummen-System, bei dem die für ein Item ausgegebenen Punkte geteilt durch die Anzahl der Raidteilnehmer für alle Teilnehmer gutgeschrieben werden. Dafür muß in dem importierenden Webscript Nullsummen-DKP aktiviert sein."
L["Start Event"] = "Mit Start Ereignis"
L["Start format"] = "Start Format"
L["Start Raid"] = "Raid beginnen"
L["Starts a new raid."] = "Einen neuen Raid beginnen."
L["Syncing"] = "Synchronisieren"
L["Syncing password"] = "Synchronisiere Passwart"
L["Syncing system for communicating DKP between raid leaders."] = "System-Synchronisation für den DKP-Abgleich zwischen den Raid-Leitern."
L["TakeBid DKP"] = "Gier-Auktions-DKP"
L["TakeBid Options"] = "Gier Auktion Optionen"
L["TAKE Percent"] = [=[NEHMEN Prozent

Feste DKP]=]
L["TAKE text"] = "Text für GIER"
L["TAKE value"] = "Erstausrüstungskosten"
L["Text of MorgBid2 NEED button"] = "Text des MorgBid2 BEDARF Knopfs"
L["Text of MorgBid2 OFFSPEC button"] = "Text des MorgBid2 OFFSPEC Knopfs"
L["Text of MorgBid2 PASS button"] = "Text des MorgBid2 PASSE Knopfs"
L["Text of MorgBid2 TAKE button"] = "Text des MorgBid2 GIER Knopfs"
L["Time in minutes between DKP awards."] = "Zeit in Minuen zwischen den DKP Zuteilungen"
L["Toggle event naming"] = "Eigene Ereignisnamen aktivieren"
L["Toggle MorgDKP2"] = "MorgDKP2 aktiv"
L["Use a bank character in raids."] = "Einen Bank Charakter in Raids verwenden."
L["Use attendance percent as a multiplier for random rolls. (roll * att/100)"] = "Anwesenheits-Prozentsatz als Multiplikator für Würfelergebnisse verwenden. (Wurf * Anwesenheit/100)"
L["Use earned DKP in the invite tablet (shift-click)."] = "Erhaltene DKP im Ladebildschirm verwenden (Shift-Klick)."
L["Use events for DKP changes instead of database adjustments."] = "DKP Änderungen als Ereignis statt als Änderung der Datenbank eintragen."
L["Use OFFSPEC"] = "OFFSPEC verwenden"
L["Use one event for entire raid.  Boss kills will not be tracked separately."] = "Schreibt den gesamten Raid in einen einzigen Eintrag. Bosskills werden nicht getrennt erfasst."
L["Use percent of item value for OFFSPEC mode."] = [=[Prozent des Itemwertes für den OFFSPEC Modus verwenden.

Feste DKP]=]
L["Use percent of item value for TAKE mode."] = [=[Prozent des Itemwertes für den NEHMEN Modus verwenden

Feste DKP]=]
L["Use start event when raid begins."] = "Start Ereignis Aufzeichnen, wenn der Raid beginnt."
L["Variation of Fixed DKP where when you bid take you also enter what you are willing to pay."] = "Eine DKP Art, bei der der Bietende bei Gier bestimmt, was er zahlen will."
L["Waitlist"] = "Warteliste"
L["Waitlist allows members to whisper you for invites and to receive DKP even if not in the actual raid."] = "Die Warteliste erlaubt es Leuten, sich per Whisper einzuladen und DKP dafür zu erhalten, dass sie in Bereitschaft sind."
L["Waitlist boss DKP"] = "Boss DKP für Warteliste"
L["Waitlist boss event name"] = "Bossname für Warteliste"
L["Waitlist DKP/time"] = "DKP/Zeit für Wateliste"
L["Waitlist event name"] = "Eventname für Warteliste"
L["Waitlist reward"] = "Zeit für Warteliste"
L["Waitlist run DKP"] = "Raid DKP für Warteliste"
L["Waitlist spamming"] = "Poste in Kanäle"
L["Waitlist start DKP"] = "Start DKP für Warteliste"
L["When MorgDKP2 is active it's loot frame will replace default."] = "Wenn MorgDKP2 aktiv ist, wird dessen Lootfenster das Standardfenster ersetzen."
L["When using the percent DKP system this option enables TAKE looting.  This means if the winning member rolled TAKE he will not be charged x% DKP he will instead be charged the base price of the item (Set using original itempoints."] = "Die Option GIER wird freigeschaltet.  Falls der Gewinner auf GIER geklickt hat, wird statt dessen der Grundpreis des Gegenstandes von seinen DKP abgezogen."
L["When you are in a tracked zone you will track DKP but you will not get the loot popup window or link to the raid.  You will act like a backup raidlog."] = "Der Tracker zeichnet nur auf.  DKPs werden aufgezeichnet, aber es erscheint weder ein Lootfenster noch werden die Lootdaten an den Raid oder die Gilde gesendet."
L["Whispers all members (even if they have MorgBid2) so they can reply and bid using whispers."] = "Flüstert an alle Teilnehmer (auch Spieler mit MorgBid2) damit sie Antworten und Gebote per flüstern abgeben können."
L["Whisper system"] = "Flüstersystem"
L["Zero player DB"] = "DKP löschen"
L["Zerosum DKP"] = "Nullsummen DKP"
L["Zerosum Options"] = "ZeroSum Optionen"

end

local L = LibStub("AceLocale-3.0"):NewLocale("MorgDKP2_Options", "esES")
	
if L then
	L["Added %s DKP to %s attendees."] = "Añadidos %s DKP a %s asistentes"
L["Allow the OFFSPEC button to be used in MorgBid2."] = "Permitir el uso del botón OFFSPEC en MorgBid2."
L["Automatically enable MorgDKP2 and start a raid when entering a trackable zone."] = "Activar automáticamente MorgDKP2 y empezar una raid cuando se entre en una zona conocida."
L["Autozone"] = "Autozona"
L["Background color"] = "Color de fondo"
L["Background texture"] = "Textura de fondo"
L["Background texture of frames/tooltips."] = "Textura de fondo de frames/tooltips"
L["Border color"] = "Color del borde"
L["Border texture"] = "Textura del borde"
L["Clear currently tracked raids."] = "Borrar las raids registradas actualmente"
L["Clear raid DB"] = "Vaciar la BD de raids"
L["Clear the raid database?"] = "¿Borrar la base de datos de raids?"
L["Developer mode"] = "Modo desarrollador"
L["DKP Modules"] = "Módulos DKP"
L["Enable"] = "Activar"
L["Enable ML/DE mode"] = "Modo ML/DE activado"
L["Enable tooltip hints"] = "Habilitar tooltips de sugerencias"
L["End Raid"] = "Finalizar raid"
L["Font"] = "Fuente"
L["Font color"] = "Color de la fuente"
L["Font size"] = "Tamaño de la fuente"
L["Font used in tooltips and frames."] = "Fuente usada en tooltips y frames"
L["Frame scale"] = "Escala del frame"
L["If ML/DE Mode is on then no items will be recorded for the master looter or disenchanter defined by MorgDKP2."] = "Si el modo ML/DE está activado los objetos no seran registrados para el maestro despojador o el desencantador definido por MorgDKP2."
L["Ignore 6-8"] = "Ignora 6-8"
L["Ignore members in groups 6-8 when querying for items."] = "Ignorar miembros en los grupos 6-8 cuando se pregunte por objetos."
L["Items will cost a percentage of the members total DKP."] = "Los objetos costarán un porcentaje de los DKP totales de los miembros"
L["Link items on the boss/mob that are above the loot threshold to guild chat."] = "Mostrar los objetos del boss/mob que esta por encima del umbral de loteo al chat de hermandad"
L["Link items on the boss/mob that are above the loot threshold to raid chat."] = "Mostrar los objetos del boss/mob que esta por encima del umbral de loteo al chat de raid"
L["Link to Guild"] = "Mostrar a la hermandad"
L["Link to Raid"] = "Mostrar a la raid"
L["MorgBid2 Options"] = "Opciones de MorgBid2"
L["MorgBid2 updating"] = "Actualizando MorgBid2"
L["Morgbid check"] = "Comprobación Morgbid"

end
	
local L = LibStub("AceLocale-3.0"):NewLocale("MorgDKP2_Options", "esMX")
	
if L then
		
end
	
local L = LibStub("AceLocale-3.0"):NewLocale("MorgDKP2_Options", "frFR")
	
if L then
	L["Added %s DKP to %s attendees."] = "%s DKP ajoutes a %s membres"
L["Allow the OFFSPEC button to be used in MorgBid2."] = "Autorise l utilisation du bouton SPE SECONDAIRE dans MorgBid2"
L["Allow updating bid results in MorgBid2."] = "Autorise la mise a jour des resultats dans MorgBid2"
L["Automatically enable MorgDKP2 and start a raid when entering a trackable zone."] = "Active automatiquement MorgDKP2 et debute un raid quand on entre dans une zone de raid"
L["Autozone"] = "Zone automatique"
L["Background color"] = "Couleur de fond"
L["Background texture"] = "Texture de fond"
L["Background texture of frames/tooltips."] = "Texture utilisee pour les fenetres et les infobulles"
L["Border color"] = "Couleur de bordure"
L["Border texture"] = "Texture de la bordure"
L["Border texture of frames/tooltips."] = "Texture de la bordure des fenetres et des infobulles"
L["Boss Attempt Mode"] = "Mode essai de boss"
L["Clear currently tracked raids."] = "Efface les raids actuellement suivis"
L["Clear raid DB"] = "Effacer la base des raids"
L["Clear the raid database?"] = "Effacer la base de raid?"
L["Core Modules"] = "Modules principaux"
L["Core of all MorgDKP2 features."] = "Coeur des fonctions de MorgDKP2"
L["Core Options"] = "Options principales"
L["Custom MorgBid2"] = "Personnaliser MorgBid2"
L[ [=[Determine MorgBid user base. 
Also useful to check DKP for alts.]=] ] = [=[Determine la base des utilisateurs MorgBid. 
Utile pour verifier les DKP des rerolls]=]
L["Developer mode"] = "Mode developpeur"
L["Display Options"] = "Options d affichage"
L["DKP Modules"] = "Modules DKP"
L["Enable ML/DE mode"] = "Activer le mode ML/DE"
L["Enables changing the text of button hints in MorgBid2."] = "Autorise la modification des textes des boutons dans MorgBid2"
L["Enable tooltip hints"] = "Active les infobulles d astuce"
L["End Raid"] = "Terminer un raid"
L["Fixed DKP"] = "DKP Fixe"
L["Font"] = "Police"
L["Font color"] = "Couleur de police"
L["Font size"] = "Taille de police"
L["Font used in tooltips and frames."] = "Police utilisee pour les infobulles et les fenetres"
L["Frame scale"] = "Echelle de la fenetre"
L["General display options for main modules."] = "Options generales pour l affichage des modules principaux"
L["If ML/DE Mode is on then no items will be recorded for the master looter or disenchanter defined by MorgDKP2."] = "Si le mode ML/DE est actif alors aucun objet ne sera enregistre pour le maitre du butin ou le desenchanteur defini par MorgDKP2"
L["Ignore 6-8"] = "Ignorer 6-8"
L["Ignore members in groups 6-8 when querying for items."] = "Ignore les joueurs dans les groupes 6 a 8 au moment des requetes des objets"
L["Link items on the boss/mob that are above the loot threshold to guild chat."] = "Montre les objets lootes dans le canal de guilde"
L["Link items on the boss/mob that are above the loot threshold to raid chat."] = "Montre les objets lootes dans le canal de raid"
L["Link to Guild"] = "Montre a la guilde"
L["Link to Raid"] = "Montrer au raid"
L["MorgBid2 Options"] = "Options de MorgBid2"
L["MorgBid2 updating"] = "Mise a jour de MorgBid2"
L["Morgbid check"] = "Verification MorgBid"
L["NEED text"] = "Texte de BESOIN"
L["OFFSPEC text"] = "Texte de SPE SECONDAIRE"
L["PASS text"] = "Texte de PASSE"
L["Show minimap icon"] = "Montrer l icone de la minimap"
L["Start Raid"] = "Commencer un raid"
L["TAKE text"] = "Texte de PREND"
L["Text of MorgBid2 NEED button"] = "Texte du bouton BESOIN de MorgBid2"
L["Text of MorgBid2 OFFSPEC button"] = "Texte du bouton SPE SECONDAIRE de MorgBid2"
L["Text of MorgBid2 PASS button"] = "Texte du bouton PASSE de MorgBid2"
L["Text of MorgBid2 TAKE button"] = "Texte du bouton PREND de MorgBid2"
L["Toggle MorgDKP2"] = "Activer/Arreter MorgDKP2"
L["Use OFFSPEC"] = "Utiliser SPE SECONDAIRE"
L["Whisper system"] = "Chuchotement système"

end
	
local L = LibStub("AceLocale-3.0"):NewLocale("MorgDKP2_Options", "koKR")
	
if L then
		
end

local L = LibStub("AceLocale-3.0"):NewLocale("MorgDKP2_Options", "ruRU")
	
if L then
	L["Accept DKP changes from other raid leaders."] = "Принимать изменения DKP от другого рейдлидера."
L["Added %s DKP to %s attendees."] = "Добавлено %s DKP %s присутствующим."
L["Add ignored item"] = "Добавить ингнорируемую вещь"
L["Add item"] = "Добавить предмет"
L["Add new item to ignore.  Drag the item to this input box."] = "Добавить вещь в игнор. Перетащите вещь в это окно"
L["Add new item to track.  Drag the item to this input box."] = "Добавить новый предмет для отслеживания. Перетащите предмет в поле ввода."
L["Allows you to change the default format for event names."] = "Позволяет Вам изменить стандартный формат названий событий"
L["Allow the OFFSPEC button to be used in MorgBid2."] = "Разрешить использование кнопки \"Оффспек\" в MorgBid2"
L["Allow updating bid results in MorgBid2."] = "Всегда обновлять результаы ставок в MorgBid2."
L["Always use"] = "Всегда использовать"
L["Always use the MorgDKP2 loot window even when the mod is in standby mode."] = "Всегда использовать окно добычи MorgDKP2, даже если аддон находится в ожидании."
L["Amount of DKP to reward after members have been on the waitlist for the current reward time."] = "Количество DKP начисляемое после того как персонажи были в списке ожидания врямя определенное для награды."
L["Amount of DKP to reward at raidstart."] = "Количество DKP начисляемое при старте."
L["Amount of DKP to reward to waitlist members per bosskill."] = "Количество DKP начисляемое персонажам в списке ожидания за убийство босса."
L["Amount of DKP to reward to waitlist members when awarding regular members DKP/time. Note: only works if you are awarding DKP/time."] = "Кол-во DKP, начисляемое персонажам в списке ожидания при начислении действительным рейдерам DKP/time. Заметка: работает только если начисляется DKP/time."
L["Attendance reward"] = "Награда за присутствие"
L["Autochannel Spam"] = "Спам в автоканал"
L["Automatic"] = "Автоматически"
L["Automatically enable MorgDKP2 and start a raid when entering a trackable zone."] = "Автоматически начинает рейд если зона есть в списке автозон."
L["Automatically set broadcast/receive depending if you are the master looter."] = "Автоматически устанавливает прием/передачу в зависимости от того мастер добычи вы или нет."
L["Autozone"] = "Автозона"
L["Award amount"] = "Размер вознаграждения"
L["Award DKP"] = "Начисляемое DKP"
L["Award DKP to current waitlist members"] = "Начислить DKP текущему списку ожидания"
L["Award time"] = "Время для вознаграждения"
L["Background color"] = "Цвет фона"
L["Background texture"] = "Текстура фона"
L["Background texture of frames/tooltips."] = "Текстура фона для окон/подсказок"
L["Bank character"] = "Персонаж-банк"
L["BaseGP"] = "БазовоеGP"
L["Bidstep"] = "Шаг ставок"
L["BidWar"] = "BidWar"
L["BidWar mode changes the MorgBid query to allow players to bid on items.  Also the MorgDKP tablet uses bids after this NOT member DKP."] = "Режим BidWar изменяет запрос MorgBid, чтобы игроки могли делать ставки на предметы. Также таблица MorgDKP использует СТАВКИ после этого а НЕ DKP персонажей."
L["BidWar Options"] = "Настройки BidWar"
L["Border color"] = "Цвет границ"
L["Border texture"] = "Текстура границ"
L["Border texture of frames/tooltips."] = "Текстура границ для окон/подсказок"
L["Boss Attempt Mode"] = "Попытка Босса"
L["Boss format"] = "Формат босса"
L["Broadcast"] = "Передача"
L["Broadcast DKP changes to other raid leaders."] = "Передача изменений DKP другим рейдлидерам."
L["Changes the DKP step for BidWar mode.  Passes this value to MorgBid2 clients."] = "Изменяет шаг DKP для режима BidWar."
L["Changes the DKP step for TakeBid mode.  Passes this value to MorgBid2 clients."] = "Изменяет шаг DKP для режима TakeBid. Передает это значение клиентам MorgBid2."
L["Channels"] = "Каналы"
L["Channels to spam when starting invites."] = "Каналы для спама при начале сбора."
L["Clear currently tracked raids."] = "Очистить записи текущего рейда"
L["Clear player DB"] = "Очистить БД персонажей"
L["Clear raid DB"] = "Очистить БД рейдов"
L["Clears all items in the database below the selected item level."] = "Удаляет все предметы в базе данных ниже выбранного ilvl."
L["Clears all members in the database inactive longer than the selected number of weeks."] = "Удаляет всех персонажей в базе данных неактивных дольше выбранного числа недель."
L["Clears all players currently in the database. Does not affect items."] = "Удаляет всех персонажей имеющихся в базе данных. Не касается предметов."
L["Clears the current tracked raids."] = "Удаляет все текущие рейды."
L["Clears the current wailist."] = "Список ожидания"
L["Clear the raid database?"] = "Очистить базу данных рейда?"
L["Clear Waitlist"] = "Очистить Список ожидания"
L["Core Modules"] = "Модули ядра"
L["Core of all MorgDKP2 features."] = [=[Ядро MorgDKP2. 
Не может быть отключено.]=]
L[ [=[Core of all MorgDKP2 raid tracking features. 
Can not be disabled.]=] ] = [=[Ядро всех особенностей рейдтрекера MorgDKP2.
Не может быть отключено.]=]
L["Core Options"] = "Опции ядра"
L["Cull item DB"] = "Отбор по базе предметов"
L["Cull item level"] = "Уровень предмета для отбора"
L["Cull member DB"] = "Отбор по базе персонажей"
L["Cull member level (weeks)"] = "Уровень(недели) персонажей для отбора"
L["Current rank weight"] = "Вес текущего ранга"
L["Custom MorgBid2"] = "Свой MorgBid2"
L["Database Functions"] = "Функции базы данных"
L["Default"] = "По умолчанию"
L[ [=[Determine MorgBid user base. 
Also useful to check DKP for alts.]=] ] = [=[Определение базы пользователей MorgBid. 
Также полезно для проверки DKP альтов.]=]
L["Developer mode"] = "Режим разработчика"
L["Display Options"] = "Настройки отображения"
L["DKP award event name"] = "Название награждаемого DKP события"
L["DKP listener"] = "Слушатель DKP"
L["DKP Modules"] = "Модули ДКП"
L["DKP TAKE/OFFSPEC settings"] = "Настройки DKP ВОЗЬМУ/ОФФСПЕК"
L["DKP/time"] = "DKP/time"
L["DKP/time event name"] = "Названия событий DKP/time"
L["DKP/time Options"] = "Настройки DKP/time"
L["DKP/time system which allows you to award DKP at custom intervals."] = "Система DKP/time позволяет начислять DKP за некоторые промежутки времени."
L["DKP Tracking"] = "Отслеживание DKP"
L["DKP which new members to the database receive."] = "DKP получаемые новыми персонажами при внесении в базу."
L["Earned DKP for Invites"] = "Заработанные DKP в таблице приглашения"
L["Enable"] = "Включено"
L["Enable BidWar mode where the winner is charged the 2nd highest bid value for the item."] = "Включает режим BidWar, где победитель платит платит за предмет в размере 2го наивысшего знчения ставок."
L["Enable BidWar mode with only one round of bidding and no reporting to raid chat."] = "Включает режим BidWar только с одним раундом ставок и без отчетов в рейдчат."
L["Enable ML/DE mode"] = "Включить режим ML/DE"
L["Enable OFFSPEC"] = "Включить ОФФСПЕК"
L["Enable raid award"] = "Включить вознаграждение рейда"
L["Enable random rolling for items."] = "Включить случайный розыгрыш для предметов."
L["Enable Relational DKP for calculating the earned/spent dkp ratio."] = "Включить Relational DKP для вычисления рейтинга заработанного/потраченного dkp."
L["Enables changing the text of button hints in MorgBid2."] = "Включает изменение текста подсказок кнопок в MorgBid2."
L["Enables DKP removed from item winner to be awarded to raid members.  You must check use zerosum on the import webscript for website DKP to be correct."] = "Позволяет награждать рейдеров DKP, списываемыми с победителя. Вы должны проставить use zerosum в скрипте на сайте DKP для правильности занесения."
L["Enables mode where members are charged a standard price for OFFSPEC items."] = "Включить режим где персонажи платят стандартную стоимость предметов на ОФФСПЕК."
L["Enables mode where members are charged a standard price for TAKE items."] = "Включить режим где персонажи платят стандартную стоимость предметов на ВОЗЬМУ."
L["Enable Suicide Kings spend all DKP."] = "Включить Suicide Kings spend all DKP."
L["Enable TAKE"] = "Включить ВОЗЬМУ"
L["Enable tooltip hints"] = "Включить всплывающие подсказки"
L["End Raid"] = "Завершить рейд"
L["Eqdkp+ event format"] = "Формат событий Eqdkp+"
L["Event Names"] = "Названия событий"
L["Event naming"] = "Названия событий"
L["Events for DKP changes"] = "События для изменения DKP"
L["Export Raids"] = "Экспорт рейда"
L["Exports current raid(s) data for import into website."] = "Экспортирует данные текущего рейда(ов) для импортирования на сайт."
L["Finalizes the current raid."] = "Завершает текущий рейд."
L["Fixed DKP"] = "Fixed DKP"
L["Font"] = "Шрифт"
L["Font color"] = "Цвет шрифта"
L["Font size"] = "Размер шрифта"
L["Font used in tooltips and frames."] = "Шрифт используемый в подсказках и фреймах"
L[ [=[Format of boss event names:  
<zone> - <boss>
Example:  <boss> <diff>]=] ] = [=[ормат названия события босса:  
<zone> - <boss>
Пример:  <boss> <diff>]=]
L[ [=[Format of event name:  
<zone> text  
Example:  <zone> DKP]=] ] = [=[Формат названий событий:  
<zone> текст  
Пример:  <zone> DKP]=]
L["Format of new member DKP event name."] = "Формат нового члена DKP имени события"
L[ [=[Format of run event name:  
<zone> text  
Example:  <zone> <diff> Run]=] ] = [=[Формат названия события захода:  
<zone> текст  
Пример:  <zone> <diff> Заход]=]
L[ [=[Format of start event name:  
<zone> text  
Example:  <zone> <diff> Start]=] ] = [=[Формат названия события старта: 
<zone> текст  
Пример:  <zone> <diff> Старт]=]
L[ [=[Format of waitlist boss events:  
<boss> text  
Example:  <boss> Waitlist DKP]=] ] = [=[Формат события босса списка ожидания:  
<boss> текст
Пример:  <boss> DKP списка ожидания]=]
L[ [=[Format of waitlist event names:  
<zone> text  
Example:  <zone> Waitlist DKP]=] ] = [=[Формат события списка ожидания:  
<zone> текст  
Пример:  <zone> DKP списка ожидания]=]
L["Frame scale"] = "Маштаб окна"
L["General display options for main modules."] = "Общие параметры отображения для модулей"
L["General options"] = "Общие настройки"
L["Grace Period"] = "Период милосердия"
L["Higher number for higher display priority. (7 will appear above 3 on the tooltip)"] = "Большее число отображается выше. (7 появится выше 3 в подсказке)"
L["If ML/DE Mode is on then no items will be recorded for the master looter or disenchanter defined by MorgDKP2."] = "Если режим ML/DE включен то лут полученный мастер лутером или дизенчатером не будет учитываться."
L["Ignore 6-8"] = "Игнорировать 6-8"
L["Ignored items"] = "Игнорируемые предметы"
L["Ignore items worn by members.  This means queries will always be sent even if they have the item."] = "Игнорировать предметы, которые носят участники. Это означает, что запрос будут всегда посылать, даже если у них будет этот предмет."
L["Ignore members in groups 6-8 when querying for items."] = "Игнорировать членов 6-8 группы в очереди на предмет"
L["Ignore worn"] = "Игнорировать носимое"
L["Immediate Sync Options"] = "Настройки немедленной синхронизации"
L["Include waitlist"] = "Включать список ожидания"
L["Include waitlist members in DKP calculations.  Note they will still get whatever DKP award is set in the waitlist module."] = "Включает список ожидания в подсчет DKP. Заметьте, что что DKP-награды, установленные в модуле списка ожидания, также будут начисляться."
L["Initial Sync"] = "Немедленная синхронизация"
L["Items Sync"] = "Синхронизация предметов"
L["Items will cost a percentage of the members total DKP."] = "Предметы будут стоить проценты от общих DKP персонажа."
L["Just enough"] = "Достаточно"
L["Link items on the boss/mob that are above the loot threshold to guild chat."] = "Сообщение о предметах выпавших с босса/моба в канал гильдии"
L["Link items on the boss/mob that are above the loot threshold to raid chat."] = "Сообщение о предметах выпавших с босса/моба в канал рейда"
L["Link to Guild"] = "Сообщения в гильдию"
L["Link to Raid"] = "Сообщения в рейд"
L["List of currently ignored items.  Click to remove item from ignore list."] = "Список игнорируемых сейчас предметов. Щелкните для удаления предмета из списка."
L["List of member ranks in the current pool."] = "Список рангов персонажей в текущем пуле."
L["Lootframe"] = "Окно добычи"
L["Lootframe scale"] = "Размер окна добычи"
L["Maximum amount of DKP that members can exceed their current DKP."] = "Максимальное количество DKP, на которое персонажи могут превысить свое DKP."
L["% Member DKP"] = "% DKP персонажа"
L["Members Sync"] = "Синхронизация персонажей"
L["Minimum amount of DKP that members can bid for an item."] = "Минимальное количество DKP, который участники могут предложить за предмет."
L["Minimum bid"] = "Минимальная ставка"
L["Minimum time before offline waitlist members will be removed."] = "Минимальное время до того как персонажи списка ожидания в оффлайне будут удалены."
L["Minimum time to add member to raid and award run DKP."] = "Минимальное время для для добавления персонажа в рейд и начисления DKP за заход."
L["Minimum time to award run DKP to a waitlist member."] = "Минимальное время для начисления DKP захода списку ожидания. "
L["MorgBid2 Options"] = "Насторойки MorgBid2"
L["MorgBid2 updating"] = "Обновление MorgBid2"
L["Morgbid check"] = "Проверка MorgBID"
L["NEED text"] = "Текст НУЖНО"
L["New member DKP event"] = "Новый член DKP события"
L["New member start DKP"] = "Начальное DKP нового персонажа"
L["OFFSPEC Percent"] = "Процент на ОФФСПЕК"
L["OFFSPEC text"] = "Текст ОФФСПЕК"
L["OFFSPEC value"] = "Стоимость ОФФСПЕК"
L["Open lootframe at cursor postition"] = "Открыть окно добычи на месте указателя"
L["Opens the raidtracker interface."] = "Открывает интерфейс рейдтрекера."
L["Options Sync"] = "Синхронизация настроек"
L["Overbid"] = "Сверхставка"
L["Overwrite raid"] = "Перезапись рейда"
L["Overwrite the current raid if you receive an initial sync and are currently in a raid."] = "Перезаписать текущий рейд если вы получаете запрос синхронизации и уже в рейде."
L["PASS text"] = "Текст ПАС"
L["Password"] = "Пароль"
L["Percent cost"] = "Стоимость в процентах"
L["Percent DKP"] = "Percent DKP"
L["Percent DKP Options"] = "Настройки Percent DKP"
L["Percent of member DKP to remove."] = "Процент DKP персонажа для списывания."
L["Percent take"] = "Процентное ВОЗЬМУ"
L["Player database cleared!"] = "База данных персонажей очищена!"
L["Player DKP reset to zero!"] = "DKP персонажей обнулено!"
L["Raid Tracker"] = "Рейдтрекер"
L["Random rolls"] = "Броски костей"
L["Rank weights"] = "Веса рангов"
L["Receive"] = "Прием"
L["Relational DKP"] = "Relational DKP"
L["Relational DKP Options"] = "Настройки Relational DKP"
L["Remember kill times"] = "Запоминать время убийства"
L["Removed %s items from the database."] = "Из базы данных удалено %s предметов."
L["Removed %s members from the database."] = "Из базы данных удалено %s персонажей."
L["Remove the ' character from any event names because eqdkp+ is dumb."] = "Удаляет символы ' из всех названий событий, потому что eqdkp+ бестолочь."
L["Replace Blizzard"] = "Заменить стандартное"
L["Resends initial sync.  Only needed in cases where you have problems as this is done automatically."] = "Посылает запрос немедленной синхронизации заного. Требуется только при наличии проблем, так как должно выполняться автоматически."
L["Reset default values."] = "Сброс значений по умолчанию"
L["Resets all members DKP to zero."] = "Обнуляет DKP всех персонажей."
L["Run format"] = "Формат захода"
L["Send DB Sync"] = "Послать запрос синхрониации базы"
L["Sends your current database of item DKP values."] = "Посылает вашу текущую базу DKP-стоимости предметов."
L["Sends your current database of member DKP values."] = "Посылает вашу текущую базу значений DKP персонажей."
L["Sends your current database of member DKP values, item values, and MorgDKP2 options to the current raid."] = "Посылает вашу текущую базу значений DKP персонажей, стоимости предметов и насторойки MorgDKP2 в текущий рейд."
L["Sends your current MorgDKP2 options.  Note will restart MorgDKP2 so do not send another sync until it restarts or use full sync and it will be handled properly."] = "Посылает ваши текущие настройки MorgDKP2. Это перезагрузит MorgDKP2 поэтому не посылайте еще синхронизацию до перезагрузки или используйте полную синхронизацию для правильного выполнения."
L["Shortcuts"] = "Ярлыки"
L["Show minimap icon"] = "Показать иконку на мини карте"
L["Silent auction"] = "Закрытый аукцион"
L["Single run event"] = "Единый заход"
L["SKall DKP"] = "SKall DKP "
L["SKall Options"] = "Настройки  SKall"
L["Snap to cursor"] = "Привязать к указателю"
L["Spam channels automatically when opening the invite tablet."] = "Спамить в каналы автоматически при открытии таблицы приглашений."
L["Spam channels with current waitlist."] = "Спамить в каналы текущий список ожидания."
L["Spam channels with waitinfo now."] = "Спамить в каналы информацию об ожидании."
L["Spam Current"] = "Спам текущих"
L["Spam Waitinfo"] = "Спам информации о списке ожидания"
L["Standard DKP system."] = "Стандартная система DKP."
L["Standard zero sum system where member is charged for the item and the charged points are divided between all raid members.  You must check use zerosum on the import webscript for website DKP to be correct."] = "Обычная zero sum система, где персонажи платят за предметы и уплаченные очки делятся между всеми рейдерами. Вы должны проверить использование zerosum в импортном скрипте сайта чтобы DKP на сайте было верным."
L["Start Event"] = "Событие старта"
L["Start format"] = "Формат старта"
L["Start Raid"] = "Запустить Рейд"
L["Starts a new raid."] = "Запустить новый рейд."
L["Store your best kill times for bosses."] = "Хранилище лучших убийств боссов по времени."
L["Syncing"] = "Синхронизация"
L["Syncing password"] = "Пароль синхронизации"
L["Syncing system for communicating DKP between raid leaders."] = "Система синхронизации для связи DKP между рейдлидерами."
L["TakeBid DKP"] = "TakeBid DKP"
L["TakeBid Options"] = "Настройки TakeBid"
L["TAKE Percent"] = "Процент на ВОЗЬМУ"
L["TAKE text"] = "Текст ВОЗЬМУ"
L["TAKE value"] = "Стоимость ВОЗЬМУ"
L["Text of MorgBid2 NEED button"] = "Текст кнопки MorgBid2 НУЖНО"
L["Text of MorgBid2 OFFSPEC button"] = "Текст кнопки MorgBid2 ОФФСПЕК"
L["Text of MorgBid2 PASS button"] = "Текст кнопки MorgBid2 ПАС"
L["Text of MorgBid2 TAKE button"] = "Текст кнопки MorgBid2 ВОЗЬМУ"
L["Time in minutes between DKP awards."] = "Время в минутах между начислением DKP"
L["Toggle event naming"] = "Переключить названия событий"
L["Toggle MorgDKP2"] = "Включить MorgDKP2"
L["Use a bank character in raids."] = "Использование персонажа-банка в рейдах."
L["Use earned DKP in the invite tablet (shift-click)."] = "Использовать заработанные DKP в таблице приглашений (shift-click)."
L["Use events for DKP changes instead of database adjustments."] = "Использовать события для изменения DKP вместо изменений базы данных."
L["Use OFFSPEC"] = "Использовать ОФФСПЕК"
L["Use one event for entire raid.  Boss kills will not be tracked separately."] = "Использовать одно событие для всего рейда. Убийства боссов не будут отслеживаться по отдельности."
L["Use percent of item value for OFFSPEC mode."] = "Использовать процентное значение стоимости для режима ОФФСПЕК"
L["Use percent of item value for TAKE mode."] = "Использовать процентное значение стоимости для режима ВОЗЬМУ"
L["Use start event when raid begins."] = "Использовать стартовое событие при начале рейда"
L["Variation of Fixed DKP where when you bid take you also enter what you are willing to pay."] = "Вариация Fixed DKP, где когда вы делаете ставку, вы также должны указать размер ставки."
L["Waitlist"] = "Список ожидания"
L["Waitlist allows members to whisper you for invites and to receive DKP even if not in the actual raid."] = "Список ожидания позволяет персонажам шептать вам для приглашения, чтобы получить DKP даже не находясь в рейде."
L["Waitlist boss DKP"] = "DKP списка ожидания за босса"
L["Waitlist boss event name"] = "Название события босса списка ожидания"
L["Waitlist DKP/time"] = "Список ожидания DKP/time"
L["Waitlist event name"] = "Название события списка ожидания"
L["Waitlist reward"] = "Награда списку ожидания"
L["Waitlist run DKP"] = "DKP списка ожидания захода"
L["Waitlist spamming"] = "Спам списка ожидания"
L["Waitlist start DKP"] = "DKP списка ожидания старта"
L["When MorgDKP2 is active it's loot frame will replace default."] = "Когда MorgDKP2 включен, его окно добычи заменит стандартное."
L["When using the percent DKP system this option enables TAKE looting.  This means if the winning member rolled TAKE he will not be charged x% DKP he will instead be charged the base price of the item (Set using original itempoints."] = "При использовании системы процентного DKP эта опция позволяет выбрать ВОЗЬМУ.  Это значит что если выигравший персонаж выбирал ВОЗЬМУ, то он не платит x% DKP, а вместо этого платит базовую стоимость предмета (Установленную исполюзуя очки предмета)."
L["When you are in a tracked zone you will track DKP but you will not get the loot popup window or link to the raid.  You will act like a backup raidlog."] = "Когда вы в отслеживаемой зоне вы будете отслеживать DKP но окно раздачи добычи и ссылки в рейд появляться не будут.  Вы будете действовать как резервный регистратор."
L["Whispers all members (even if they have MorgBid2) so they can reply and bid using whispers."] = "Шептать всем персонажам (даже если у них есть MorgBid2) для того, чтобы они смогли ответить и сделать ставку используя шепот."
L["Whisper system"] = "Система шепота"
L["Zero player DB"] = "Обнулить БД персонажей"
L["Zerosum DKP"] = "Zerosum DKP"
L["Zerosum Options"] = "Настройки Zerosum"

end	
	
local L = LibStub("AceLocale-3.0"):NewLocale("MorgDKP2_Options", "zhCN")
	
if L then
	L["Add ignored item"] = "添加忽略物品"
L["Add new item to ignore.  Drag the item to this input box."] = "添加需要忽略的物品，将它拖入到这个输入框中。"
L["Background color"] = "背景颜色"
L["Background texture"] = "背景材质"
L["Background texture of frames/tooltips."] = "框体或鼠标提示的背景材质"
L["Border color"] = "边框颜色"
L["Border texture"] = "边框材质"
L["Border texture of frames/tooltips."] = "框体或鼠标提示的边框材质"
L["Clear raid DB"] = "清空活动数据"
L["Clear the raid database?"] = "确定要清空活动数据？"
L["Developer mode"] = "开发模式"

end
	
local L = LibStub("AceLocale-3.0"):NewLocale("MorgDKP2_Options", "zhTW")
	
if L then
	L["Added %s DKP to %s attendees."] = "增加 %s DKP 給予 %s 出席者。"
L["Add item"] = "新增物品"
L["Background color"] = "背景顏色"
L["Channels"] = "頻道"
L["Default"] = "預設"
L["Enable"] = "啟用"
L["Password"] = "密碼"
L["Waitlist"] = "等待名單"

end
